(*
  Copyright 2010 Gerd Stolpmann

  This file is part of Plasma, a distributed filesystem and a
  map/reduce computation framework. Unless you have a written license
  agreement with the copyright holder (Gerd Stolpmann), the following
  terms apply:

  Plasma is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Plasma is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

*)
(* $Id: dn_io.mli 239 2010-06-23 16:49:03Z gerd $ *)

val factory : unit -> Netplex_types.processor_factory
  (** Returns this as factory for inclusion into [Netplex_main.startup] *)

val add_service : 
      Dn_config.dn_config -> 
      Netplex_types.config_file ->
      Netplex_types.address ->
      Netplex_types.controller ->
        unit
  (** Adds the [Dn_io] service directly to the controller. This way, there is
      no need to configure it in the config file. This function is called
      from [Dn_manager] when [Dn_manager] is enabled in the config file.
   *)
